<template>
  <div id="toastmessage">
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { ToastPlugin } from 'bootstrap-vue';
import axios from 'axios';

Vue.use(ToastPlugin);

export default Vue.extend({
  name: 'toastmessage',
  data() {
    return {
      intervalFunction: 0,
    };
  },
  mounted() {
    this.intervalFunction = window.setInterval(this.checkAvailability, 5 * 60 * 1000);
  },
  methods: {
    checkAvailability() {
      // calls a function in the backend to see if the session is still valid
      axios.post(_spPageContextInfo.webAbsoluteUrl + '/_api/contextinfo')
      .then((response: any) => { return; })
      .catch((error: any) => {
        // the session is not valid anymore
        // show notification and cancel the check
        this.popToast();
        clearInterval(this.intervalFunction);
      });
    },
    login() {
      window.location.reload();
    },
    popToast() {
        const h = this.$createElement;
        // Create the message
        const message = h(
          'p',
          { class: ['text-center', 'mb-0'] },
          [
            this.$t('message').toString(),
            h('br'),
            h('b-button', {
              on: { click: this.login },
              domProps: {
                innerHTML: this.$t('link').toString(),
              },
            }),
          ],
        );
        this.$bvToast.toast([message], {
          title: this.$t('title').toString(),
          solid: true,
          noAutoHide: true,
          toaster: 'b-toaster-bottom-right',
          noCloseButton: true,
          headerClass: 'toast-header-danger',
        });
      },
    },
});
</script>

<style>
.toast-header button.close {
  position: absolute;
  right: -45px;
}

.toast-header-danger {
  color: white;
  background-color: rgb(204, 7, 30);
}
</style>
